local toc, privateData = ...
local AddonId = toc.identifier

RA = {}
RA.Settings = {}
RA.Availability = "none"
RA.ItemUpdateWait = false
RA.Function = {}
RA.Function.Event = {}
RA.Items = {}
RA.Items.Banners = {}
RA.Items.Scrolls = {}
RA.Items.Banners.HasBanners = false
RA.Items.Banners.location = nil
RA.Items.Scrolls.HasScrolls = false
RA.Items.Scrolls.location = nil
RA.Items.Scrolls.OnCooldown = false
RA.RallyBannerUsable = true
RA.RallyTimeTriggered = 0
RA.RallyTimeout = 0
RA.RedoItemUpdate = false
RA.ItemRescanTime = 0

RA.Context = UI.CreateContext("raContext")
RA.AlertContext = UI.CreateContext("raContextAlert")
RA.AlertContext:SetStrata("topmost")

-- special case using last banner, need logic to handle

function RA.CreateOptions()
	if not Inspect.System.Secure() then
		Command.System.Watchdog.Quiet()
	end
	
	RA.Options = UI.CreateFrame("Frame", AddonId .. "_Options", RA.Context)
		RA.Options:SetPoint("TOPLEFT", RA.Context, "TOPLEFT", UIParent:GetWidth()/5, UIParent:GetHeight()/7)
		RA.Options:SetHeight(450)
		RA.Options:SetWidth(370)
		RA.Options:SetVisible(true)
		RA.Options:SetLayer(0)
		RA.Options:SetBackgroundColor(0.91,0.424,0.098,1)
		RA.Options.dragging = false
		
	RA.Options.Title = UI.CreateFrame("Frame", AddonId .. "_Options_Title", RA.Options)
		RA.Options.Title:SetPoint("TOPLEFT", RA.Options, "TOPLEFT" , 2, 2)
		RA.Options.Title:SetPoint("BOTTOMRIGHT", RA.Options, "TOPRIGHT" , -2, 24)
		RA.Options.Title:SetVisible(true)
		RA.Options.Title:SetLayer(5)
		RA.Options.Title:SetBackgroundColor(0,0,0,1)
		
	RA.Options.Title.Text = UI.CreateFrame("Text", AddonId .. "_Options_Title_Text", RA.Options.Title)
		RA.Options.Title.Text:SetPoint("CENTER", RA.Options.Title, "CENTER")
		RA.Options.Title.Text:SetFontColor(1,1,1,1)
		RA.Options.Title.Text:SetEffectGlow({colorR = 0.91, colorG = 0.424, colorB = 0.098, strength = 5, blurX = 1.5, blurY = 1.5})
		RA.Options.Title.Text:SetText("Rally Alert " .. toc.toc.Version)
		RA.Options.Title.Text:SetLayer(10)
		RA.Options.Title.Text:SetFontSize(16)
		
	RA.Options.Display = UI.CreateFrame("Frame", AddonId .. "_Options_Body", RA.Options)
		RA.Options.Display:SetPoint("TOPLEFT", RA.Options.Title, "BOTTOMLEFT" , 0, 2)
		RA.Options.Display:SetPoint("BOTTOMRIGHT", RA.Options, "BOTTOMRIGHT" , -2, -2)
		RA.Options.Display:SetVisible(true)
		RA.Options.Display:SetLayer(5)
		RA.Options.Display:SetBackgroundColor(0,0,0,1)
		
	RA.Options.Display.Mask = UI.CreateFrame("Mask", AddonId .. "_Options_Display_Mask", RA.Options.Display)
		RA.Options.Display.Mask:SetPoint("TOPLEFT", RA.Options.Display, "TOPLEFT")
		RA.Options.Display.Mask:SetPoint("BOTTOMRIGHT", RA.Options.Display, "BOTTOMRIGHT")
		RA.Options.Display.Mask:SetLayer(10)
		
	RA.Options.Display.Body = UI.CreateFrame("Frame", AddonId .. "_Options_Display_Body", RA.Options.Display.Mask)
		RA.Options.Display.Body:SetPoint("TOPLEFT", RA.Options.Display, 0,0)
		RA.Options.Display.Body:SetWidth(326)
		RA.Options.Display.Body:SetHeight(600)
		RA.Options.Display.Body:SetLayer(15)
		RA.Options.Display.Body:SetBackgroundColor(0,0,0,1)
		
		RA.Options.Display.Scrollbar = UI.CreateFrame("Frame", AddonId .. "_Options_Display_Body_ScrollBar", RA.Options.Display)
			RA.Options.Display.Scrollbar:SetPoint("TOPLEFT", RA.Options.Display, "TOPRIGHT", -21, 0)
			RA.Options.Display.Scrollbar:SetPoint("BOTTOMRIGHT", RA.Options.Display, "BOTTOMRIGHT")
			RA.Options.Display.Scrollbar:SetLayer(10)
			RA.Options.Display.Scrollbar.dragging = false
			
			RA.Options.Display.Scrollbar.line = UI.CreateFrame("Frame", AddonId .. "_Options_Display_Body_ScrollBar_Line", RA.Options.Display.Scrollbar)
				RA.Options.Display.Scrollbar.line:SetPoint("TOPLEFT", RA.Options.Display.Scrollbar, "TOPCENTER", -1, 4)
				RA.Options.Display.Scrollbar.line:SetPoint("BOTTOMRIGHT", RA.Options.Display.Scrollbar, "BOTTOMCENTER", 1, -4)
				RA.Options.Display.Scrollbar.line:SetBackgroundColor(0.91,0.424,0.098,1)
				RA.Options.Display.Scrollbar.line:SetLayer(15)
				
			RA.Options.Display.Scrollbar.handle = UI.CreateFrame("Frame", AddonId .. "_Options_Display_Body_ScrollBar_Line_handle", RA.Options.Display.Scrollbar)
				RA.Options.Display.Scrollbar.handle:SetPoint("TOPCENTER", RA.Options.Display.Scrollbar.line, 0.5,0)
				local window = RA.Options.Display:GetHeight()
				local body = RA.Options.Display.Body:GetHeight()
				local percent = window/body
				RA.Options.Display.Scrollbar.handle.range = (1-percent)
				RA.Options.Display.Scrollbar.handle:SetHeight(percent*RA.Options.Display.Scrollbar.line:GetHeight())
				RA.Options.Display.Scrollbar.handle:SetWidth(12)
				RA.Options.Display.Scrollbar.handle:SetBackgroundColor(0.91,0.424,0.098,1)
				RA.Options.Display.Scrollbar.handle:SetLayer(20)
				
				RA.Options.Display.Scrollbar.handle.body = UI.CreateFrame("Frame", AddonId .. "_Options_Display_Body_ScrollBar_Line_handle_body", RA.Options.Display.Scrollbar.handle)
					RA.Options.Display.Scrollbar.handle.body:SetPoint("TOPLEFT", RA.Options.Display.Scrollbar.handle, "TOPLEFT", 1, 1)
					RA.Options.Display.Scrollbar.handle.body:SetPoint("BOTTOMRIGHT", RA.Options.Display.Scrollbar.handle, "BOTTOMRIGHT", -1, -1)
					RA.Options.Display.Scrollbar.handle.body:SetLayer(25)
					RA.Options.Display.Scrollbar.handle.body:SetBackgroundColor(0,0,0,1)

		RA.Options.Display.Body.title = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_title", RA.Options.Display.Body)
			RA.Options.Display.Body.title:SetPoint("TOPCENTER", RA.Options.Display.Body, "TOPCENTER")
			RA.Options.Display.Body.title:SetFontColor(1,1,1,1)
			RA.Options.Display.Body.title:SetText("Options")
			RA.Options.Display.Body.title:SetLayer(20)
			RA.Options.Display.Body.title:SetFontSize(30)
			
		RA.Options.Display.Body.Scroll = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Scroll", RA.Options.Display.Body)
			RA.Options.Display.Body.Scroll:SetPoint("TOPLEFT", RA.Options.Display.Body, "TOPLEFT", 10, 50)
			RA.Options.Display.Body.Scroll:SetFontColor(1,1,1,1)
			RA.Options.Display.Body.Scroll:SetEffectGlow({colorR = 0.91, colorG = 0.424, colorB = 0.098, strength = 5, blurX = 1.5, blurY = 1.5})
			RA.Options.Display.Body.Scroll:SetText("Scroll Available")
			RA.Options.Display.Body.Scroll:SetLayer(20)
			RA.Options.Display.Body.Scroll:SetFontSize(20)
			
			RA.Options.Display.Body.Scroll.cbk = UI.CreateFrame("RiftCheckbox", AddonId .. "_Options_Display_Body_Scroll_cbk", RA.Options.Display.Body.Scroll)
				RA.Options.Display.Body.Scroll.cbk:SetPoint("TOPLEFT", RA.Options.Display.Body.Scroll, "BOTTOMLEFT", 10, 5)
				RA.Options.Display.Body.Scroll.cbk:SetVisible(true)
				RA.Options.Display.Body.Scroll.cbk:SetEnabled(true)
				RA.Options.Display.Body.Scroll.cbk:SetChecked(RA.Settings.Scroll)
				RA.Options.Display.Body.Scroll.cbk:EventAttach(Event.UI.Checkbox.Change, function()
					RA.Settings.Scroll = RA.Options.Display.Body.Scroll.cbk:GetChecked()
				end, AddonId .. "_Options_Body_Scroll_CheckBoxChange")
		
			RA.Options.Display.Body.Scroll.text = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Scroll_text", RA.Options.Display.Body.Scroll)
				RA.Options.Display.Body.Scroll.text:SetPoint("TOPLEFT", RA.Options.Display.Body.Scroll.cbk, "TOPRIGHT", 5, -3)
				RA.Options.Display.Body.Scroll.text:SetFontSize(14)
				RA.Options.Display.Body.Scroll.text:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Scroll.text:SetText("Only Alert when Rally Scroll is off cooldown")
				
		RA.Options.Display.Body.Timeout = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Timeout", RA.Options.Display.Body)
			RA.Options.Display.Body.Timeout:SetPoint("TOPLEFT", RA.Options.Display.Body.Scroll, "BOTTOMLEFT", 0, 30)
			RA.Options.Display.Body.Timeout:SetFontColor(1,1,1,1)
			RA.Options.Display.Body.Timeout:SetEffectGlow({colorR = 0.91, colorG = 0.424, colorB = 0.098, strength = 5, blurX = 1.5, blurY = 1.5})
			RA.Options.Display.Body.Timeout:SetText("Timeout Duration")
			RA.Options.Display.Body.Timeout:SetLayer(20)
			RA.Options.Display.Body.Timeout:SetFontSize(20)
			
			RA.Options.Display.Body.Timeout.Text = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Timeout_Text", RA.Options.Display.Body.Timeout)
				RA.Options.Display.Body.Timeout.Text:SetPoint("TOPLEFT", RA.Options.Display.Body.Timeout, "BOTTOMLEFT", 10, 5)
				RA.Options.Display.Body.Timeout.Text:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Timeout.Text:SetFontSize(14)
				RA.Options.Display.Body.Timeout.Text:SetText("Length of time, in seconds, to display the alert")
				
			RA.Options.Display.Body.Timeout.Text2 = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Timeout_Text2", RA.Options.Display.Body.Timeout)
				RA.Options.Display.Body.Timeout.Text2:SetPoint("TOPLEFT", RA.Options.Display.Body.Timeout.Text, "BOTTOMLEFT", 0, -2)
				RA.Options.Display.Body.Timeout.Text2:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Timeout.Text2:SetFontSize(14)
				RA.Options.Display.Body.Timeout.Text2:SetText("Overridden by using Rally Scroll or Banner ending")
				
			RA.Options.Display.Body.Timeout.Text3 = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Timeout_Text3", RA.Options.Display.Body.Timeout)
				RA.Options.Display.Body.Timeout.Text3:SetPoint("TOPLEFT", RA.Options.Display.Body.Timeout.Text2, "BOTTOMLEFT", 0, -2)
				RA.Options.Display.Body.Timeout.Text3:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Timeout.Text3:SetFontSize(14)
				RA.Options.Display.Body.Timeout.Text3:SetText("Duration: " .. tostring(RA.Settings.Timeout) .. " seconds")
				
			RA.Options.Display.Body.Timeout.Slider = UI.CreateFrame("RiftSlider", AddonId .. "_Options_Display_Body_Timeout_Slider", RA.Options.Display.Body.Timeout)
				RA.Options.Display.Body.Timeout.Slider:SetPoint("TOPLEFT", RA.Options.Display.Body.Timeout.Text3, "BOTTOMLEFT", 5, 5)
				RA.Options.Display.Body.Timeout.Slider:SetRange(0,600)
				RA.Options.Display.Body.Timeout.Slider:SetWidth(300)
				RA.Options.Display.Body.Timeout.Slider:SetPosition(RA.Settings.Timeout)
				RA.Options.Display.Body.Timeout.Slider:EventAttach(Event.UI.Slider.Change, function()
					RA.Options.Display.Body.Timeout.Text3:SetText("Duration: " .. tostring(RA.Options.Display.Body.Timeout.Slider:GetPosition()) .. " seconds")
					RA.Settings.Timeout = RA.Options.Display.Body.Timeout.Slider:GetPosition()
				end, AddonId .. "_Options_Body_Timeout_SliderChange")
			
		RA.Options.Display.Body.Size = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Size", RA.Options.Display.Body)
			RA.Options.Display.Body.Size:SetPoint("TOPLEFT", RA.Options.Display.Body.Scroll, "BOTTOMLEFT", 0, 152)
			RA.Options.Display.Body.Size:SetFontColor(1,1,1,1)
			RA.Options.Display.Body.Size:SetEffectGlow({colorR = 0.91, colorG = 0.424, colorB = 0.098, strength = 5, blurX = 1.5, blurY = 1.5})
			RA.Options.Display.Body.Size:SetText("Size")
			RA.Options.Display.Body.Size:SetLayer(20)
			RA.Options.Display.Body.Size:SetFontSize(20)
			
			RA.Options.Display.Body.Size.Text = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Size_Text", RA.Options.Display.Body.Size)
				RA.Options.Display.Body.Size.Text:SetPoint("TOPLEFT", RA.Options.Display.Body.Size, "BOTTOMLEFT", 10, 5)
				RA.Options.Display.Body.Size.Text:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Size.Text:SetFontSize(14)
				RA.Options.Display.Body.Size.Text:SetText("Alert Text Size: " .. tostring(RA.Settings.Size) .. "px")
				
			RA.Options.Display.Body.Size.Slider = UI.CreateFrame("RiftSlider", AddonId .. "_Options_Display_Body_Size_Slider", RA.Options.Display.Body.Size)
				RA.Options.Display.Body.Size.Slider:SetPoint("TOPLEFT", RA.Options.Display.Body.Size.Text, "BOTTOMLEFT", 5, 5)
				RA.Options.Display.Body.Size.Slider:SetRange(10,150)
				RA.Options.Display.Body.Size.Slider:SetWidth(300)
				RA.Options.Display.Body.Size.Slider:SetPosition(RA.Settings.Size)
				RA.Options.Display.Body.Size.Slider:EventAttach(Event.UI.Slider.Change, function()
					RA.Alert:SetFontSize(RA.Options.Display.Body.Size.Slider:GetPosition())
					RA.Alert.Frame:SetWidth(RA.Alert:GetWidth())
					RA.Alert.Frame:SetHeight(RA.Alert:GetHeight())
					RA.Options.Display.Body.Size.Text:SetText("Alert Text Size: " .. tostring(RA.Options.Display.Body.Size.Slider:GetPosition()) .. "px")
					RA.Settings.Size = RA.Options.Display.Body.Size.Slider:GetPosition()
				end, AddonId .. "_Options_Body_Size_SliderChange")
				
		RA.Options.Display.Body.Color = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color", RA.Options.Display.Body)
			RA.Options.Display.Body.Color:SetPoint("TOPLEFT", RA.Options.Display.Body.Size, "BOTTOMLEFT", 0, 50)
			RA.Options.Display.Body.Color:SetFontColor(1,1,1,1)
			RA.Options.Display.Body.Color:SetEffectGlow({colorR = 0.91, colorG = 0.424, colorB = 0.098, strength = 5, blurX = 1.5, blurY = 1.5})
			RA.Options.Display.Body.Color:SetText("Color")
			RA.Options.Display.Body.Color:SetLayer(20)
			RA.Options.Display.Body.Color:SetFontSize(20)
			
			RA.Options.Display.Body.Color.Text = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_Text", RA.Options.Display.Body.Color)
				RA.Options.Display.Body.Color.Text:SetPoint("TOPLEFT", RA.Options.Display.Body.Color, "BOTTOMLEFT", 10, 5)
				RA.Options.Display.Body.Color.Text:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Color.Text:SetFontSize(14)
				RA.Options.Display.Body.Color.Text:SetText("Text Color")
				
			RA.Options.Display.Body.Color.Text.border = UI.CreateFrame("Frame", AddonId .. "_Options_Display_Body_Color_border", RA.Options.Display.Body.Color.Text)
				RA.Options.Display.Body.Color.Text.border:SetPoint("TOPLEFT", RA.Options.Display.Body.Color.Text, "BOTTOMLEFT", 5, 5)
				RA.Options.Display.Body.Color.Text.border:SetHeight(80)
				RA.Options.Display.Body.Color.Text.border:SetWidth(45)
				RA.Options.Display.Body.Color.Text.border:SetLayer(20)
				RA.Options.Display.Body.Color.Text.border:SetBackgroundColor(1,1,1,1)
			
			RA.Options.Display.Body.Color.Text.preview = UI.CreateFrame("Frame", AddonId .. "_Options_Display_Body_Color_preview", RA.Options.Display.Body.Color.Text)
				RA.Options.Display.Body.Color.Text.preview:SetPoint("TOPLEFT", RA.Options.Display.Body.Color.Text.border, "TOPLEFT", 1, 1)
				RA.Options.Display.Body.Color.Text.preview:SetPoint("BOTTOMRIGHT", RA.Options.Display.Body.Color.Text.border, "BOTTOMRIGHT", -1, -1)
				RA.Options.Display.Body.Color.Text.preview:SetLayer(30)
				RA.Options.Display.Body.Color.Text.preview:SetBackgroundColor(RA.Settings.Color.Text.r,RA.Settings.Color.Text.g,RA.Settings.Color.Text.b,1)
			
			RA.Options.Display.Body.Color.Text.red = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_red", RA.Options.Display.Body.Color.Text)
				RA.Options.Display.Body.Color.Text.red:SetPoint("TOPLEFT", RA.Options.Display.Body.Color.Text.border, "TOPRIGHT", 22, 0)
				RA.Options.Display.Body.Color.Text.red:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Color.Text.red:SetFontSize(12)
				RA.Options.Display.Body.Color.Text.red:SetText("Red")
			
				RA.Options.Display.Body.Color.Text.red.slider = UI.CreateFrame("RiftSlider", AddonId .. "_Options_Display_Body_Color_red_slider", RA.Options.Display.Body.Color.Text.red)
					RA.Options.Display.Body.Color.Text.red.slider:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Text.red, "CENTERRIGHT", 12, 6)
					RA.Options.Display.Body.Color.Text.red.slider:SetRange(0,255)
					RA.Options.Display.Body.Color.Text.red.slider:SetWidth(165)
					RA.Options.Display.Body.Color.Text.red.slider:SetPosition(math.floor(RA.Settings.Color.Text.r*255))
					RA.Options.Display.Body.Color.Text.red.slider:EventAttach(Event.UI.Slider.Change, function()
						RA.Options.Display.Body.Color.Text.red.value:SetText(tostring(RA.Options.Display.Body.Color.Text.red.slider:GetPosition()))
						RA.Options.Display.Body.Color.Text.preview:SetBackgroundColor(RA.Options.Display.Body.Color.Text.red.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.green.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.blue.slider:GetPosition()/255,1)
						RA.Alert:SetFontColor(RA.Options.Display.Body.Color.Text.red.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.green.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.blue.slider:GetPosition()/255,1)
						RA.Settings.Color.Text.r = RA.Options.Display.Body.Color.Text.red.slider:GetPosition()/255
					end, AddonId .. "_Options_Display_Body_Color_red_slider_Change")
				
				RA.Options.Display.Body.Color.Text.red.value = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_red_value", RA.Options.Display.Body.Color.Text.red)
					RA.Options.Display.Body.Color.Text.red.value:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Text.red.slider, "CENTERRIGHT", 12, -6)
					RA.Options.Display.Body.Color.Text.red.value:SetFontColor(1,1,1,1)
					RA.Options.Display.Body.Color.Text.red.value:SetFontSize(12)
					RA.Options.Display.Body.Color.Text.red.value:SetText(tostring(RA.Options.Display.Body.Color.Text.red.slider:GetPosition()))
			
			RA.Options.Display.Body.Color.Text.green = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_green", RA.Options.Display.Body.Color.Text)
				RA.Options.Display.Body.Color.Text.green:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Text.border, "CENTERRIGHT", 10, 0)
				RA.Options.Display.Body.Color.Text.green:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Color.Text.green:SetFontSize(12)
				RA.Options.Display.Body.Color.Text.green:SetText("Green")
			
				RA.Options.Display.Body.Color.Text.green.slider = UI.CreateFrame("RiftSlider", AddonId .. "_Options_Display_Body_Color_green_slider", RA.Options.Display.Body.Color.Text.green)
					RA.Options.Display.Body.Color.Text.green.slider:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Text.green, "CENTERRIGHT", 12, 6)
					RA.Options.Display.Body.Color.Text.green.slider:SetRange(0,255)
					RA.Options.Display.Body.Color.Text.green.slider:SetWidth(165)
					RA.Options.Display.Body.Color.Text.green.slider:SetPosition(math.floor(RA.Settings.Color.Text.g*255))
					RA.Options.Display.Body.Color.Text.green.slider:EventAttach(Event.UI.Slider.Change, function()
						RA.Options.Display.Body.Color.Text.green.value:SetText(tostring(RA.Options.Display.Body.Color.Text.green.slider:GetPosition()))
						RA.Options.Display.Body.Color.Text.preview:SetBackgroundColor(RA.Options.Display.Body.Color.Text.red.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.green.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.blue.slider:GetPosition()/255,1)
						RA.Alert:SetFontColor(RA.Options.Display.Body.Color.Text.red.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.green.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.blue.slider:GetPosition()/255,1)
						RA.Settings.Color.Text.g = RA.Options.Display.Body.Color.Text.green.slider:GetPosition()/255
					end, AddonId .. "_Options_Display_Body_Color_green_slider_Change")
				
				RA.Options.Display.Body.Color.Text.green.value = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_green_value", RA.Options.Display.Body.Color.Text.green)
					RA.Options.Display.Body.Color.Text.green.value:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Text.green.slider, "CENTERRIGHT", 12, -6)
					RA.Options.Display.Body.Color.Text.green.value:SetFontColor(1,1,1,1)
					RA.Options.Display.Body.Color.Text.green.value:SetFontSize(12)
					RA.Options.Display.Body.Color.Text.green.value:SetText(tostring(RA.Options.Display.Body.Color.Text.green.slider:GetPosition()))
			
			RA.Options.Display.Body.Color.Text.blue = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_blue", RA.Options.Display.Body.Color.Text)
				RA.Options.Display.Body.Color.Text.blue:SetPoint("BOTTOMLEFT", RA.Options.Display.Body.Color.Text.border, "BOTTOMRIGHT", 19, 0)
				RA.Options.Display.Body.Color.Text.blue:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Color.Text.blue:SetFontSize(12)
				RA.Options.Display.Body.Color.Text.blue:SetText("Blue")
			
				RA.Options.Display.Body.Color.Text.blue.slider = UI.CreateFrame("RiftSlider", AddonId .. "_Options_Display_Body_Color_blue_slider", RA.Options.Display.Body.Color.Text.blue)
					RA.Options.Display.Body.Color.Text.blue.slider:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Text.blue, "CENTERRIGHT", 12, 6)
					RA.Options.Display.Body.Color.Text.blue.slider:SetRange(0,255)
					RA.Options.Display.Body.Color.Text.blue.slider:SetWidth(165)
					RA.Options.Display.Body.Color.Text.blue.slider:SetPosition(math.floor(RA.Settings.Color.Text.b*255))
					RA.Options.Display.Body.Color.Text.blue.slider:EventAttach(Event.UI.Slider.Change, function()
						RA.Options.Display.Body.Color.Text.blue.value:SetText(tostring(RA.Options.Display.Body.Color.Text.blue.slider:GetPosition()))
						RA.Options.Display.Body.Color.Text.preview:SetBackgroundColor(RA.Options.Display.Body.Color.Text.red.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.green.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.blue.slider:GetPosition()/255,1)
						RA.Alert:SetFontColor(RA.Options.Display.Body.Color.Text.red.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.green.slider:GetPosition()/255,RA.Options.Display.Body.Color.Text.blue.slider:GetPosition()/255,1)
						RA.Settings.Color.Text.b = RA.Options.Display.Body.Color.Text.blue.slider:GetPosition()/255
					end, AddonId .. "_Options_Display_Body_Color_blue_slider_Change")
				
				RA.Options.Display.Body.Color.Text.blue.value = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_blue_value", RA.Options.Display.Body.Color.Text.blue)
					RA.Options.Display.Body.Color.Text.blue.value:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Text.blue.slider, "CENTERRIGHT", 12, -6)
					RA.Options.Display.Body.Color.Text.blue.value:SetFontColor(1,1,1,1)
					RA.Options.Display.Body.Color.Text.blue.value:SetFontSize(12)
					RA.Options.Display.Body.Color.Text.blue.value:SetText(tostring(RA.Options.Display.Body.Color.Text.blue.slider:GetPosition()))
				
				
			RA.Options.Display.Body.Color.Glow = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_Glow", RA.Options.Display.Body.Color)
				RA.Options.Display.Body.Color.Glow:SetPoint("TOPLEFT", RA.Options.Display.Body.Color.Text.border, "BOTTOMLEFT", -5, 10)
				RA.Options.Display.Body.Color.Glow:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Color.Glow:SetFontSize(14)
				RA.Options.Display.Body.Color.Glow:SetText("Glow Color")
				
			RA.Options.Display.Body.Color.Glow.border = UI.CreateFrame("Frame", AddonId .. "_Options_Display_Body_Color_border", RA.Options.Display.Body.Color.Glow)
				RA.Options.Display.Body.Color.Glow.border:SetPoint("TOPLEFT", RA.Options.Display.Body.Color.Glow, "BOTTOMLEFT", 5, 5)
				RA.Options.Display.Body.Color.Glow.border:SetHeight(80)
				RA.Options.Display.Body.Color.Glow.border:SetWidth(45)
				RA.Options.Display.Body.Color.Glow.border:SetLayer(20)
				RA.Options.Display.Body.Color.Glow.border:SetBackgroundColor(1,1,1,1)
			
			RA.Options.Display.Body.Color.Glow.preview = UI.CreateFrame("Frame", AddonId .. "_Options_Display_Body_Color_preview", RA.Options.Display.Body.Color.Glow)
				RA.Options.Display.Body.Color.Glow.preview:SetPoint("TOPLEFT", RA.Options.Display.Body.Color.Glow.border, "TOPLEFT", 1, 1)
				RA.Options.Display.Body.Color.Glow.preview:SetPoint("BOTTOMRIGHT", RA.Options.Display.Body.Color.Glow.border, "BOTTOMRIGHT", -1, -1)
				RA.Options.Display.Body.Color.Glow.preview:SetLayer(30)
				RA.Options.Display.Body.Color.Glow.preview:SetBackgroundColor(RA.Settings.Color.Glow.colorR,RA.Settings.Color.Glow.colorG,RA.Settings.Color.Glow.colorB,1)
			
			RA.Options.Display.Body.Color.Glow.red = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_red", RA.Options.Display.Body.Color.Glow)
				RA.Options.Display.Body.Color.Glow.red:SetPoint("TOPLEFT", RA.Options.Display.Body.Color.Glow.border, "TOPRIGHT", 22, 0)
				RA.Options.Display.Body.Color.Glow.red:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Color.Glow.red:SetFontSize(12)
				RA.Options.Display.Body.Color.Glow.red:SetText("Red")
			
				RA.Options.Display.Body.Color.Glow.red.slider = UI.CreateFrame("RiftSlider", AddonId .. "_Options_Display_Body_Color_red_slider", RA.Options.Display.Body.Color.Glow.red)
					RA.Options.Display.Body.Color.Glow.red.slider:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Glow.red, "CENTERRIGHT", 12, 6)
					RA.Options.Display.Body.Color.Glow.red.slider:SetRange(0,255)
					RA.Options.Display.Body.Color.Glow.red.slider:SetWidth(165)
					RA.Options.Display.Body.Color.Glow.red.slider:SetPosition(math.floor(RA.Settings.Color.Glow.colorR*255))
					RA.Options.Display.Body.Color.Glow.red.slider:EventAttach(Event.UI.Slider.Change, function()
						RA.Options.Display.Body.Color.Glow.red.value:SetText(tostring(RA.Options.Display.Body.Color.Glow.red.slider:GetPosition()))
						RA.Options.Display.Body.Color.Glow.preview:SetBackgroundColor(RA.Options.Display.Body.Color.Glow.red.slider:GetPosition()/255,RA.Options.Display.Body.Color.Glow.green.slider:GetPosition()/255,RA.Options.Display.Body.Color.Glow.blue.slider:GetPosition()/255,1)
						RA.Settings.Color.Glow.colorR = RA.Options.Display.Body.Color.Glow.red.slider:GetPosition()/255
						RA.Alert:SetEffectGlow(RA.Settings.Color.Glow)
					end, AddonId .. "_Options_Display_Body_Color_red_slider_Change")
				
				RA.Options.Display.Body.Color.Glow.red.value = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_red_value", RA.Options.Display.Body.Color.Glow.red)
					RA.Options.Display.Body.Color.Glow.red.value:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Glow.red.slider, "CENTERRIGHT", 12, -6)
					RA.Options.Display.Body.Color.Glow.red.value:SetFontColor(1,1,1,1)
					RA.Options.Display.Body.Color.Glow.red.value:SetFontSize(12)
					RA.Options.Display.Body.Color.Glow.red.value:SetText(tostring(RA.Options.Display.Body.Color.Glow.red.slider:GetPosition()))
			
			RA.Options.Display.Body.Color.Glow.green = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_green", RA.Options.Display.Body.Color.Glow)
				RA.Options.Display.Body.Color.Glow.green:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Glow.border, "CENTERRIGHT", 10, 0)
				RA.Options.Display.Body.Color.Glow.green:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Color.Glow.green:SetFontSize(12)
				RA.Options.Display.Body.Color.Glow.green:SetText("Green")
			
				RA.Options.Display.Body.Color.Glow.green.slider = UI.CreateFrame("RiftSlider", AddonId .. "_Options_Display_Body_Color_green_slider", RA.Options.Display.Body.Color.Glow.green)
					RA.Options.Display.Body.Color.Glow.green.slider:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Glow.green, "CENTERRIGHT", 12, 6)
					RA.Options.Display.Body.Color.Glow.green.slider:SetRange(0,255)
					RA.Options.Display.Body.Color.Glow.green.slider:SetWidth(165)
					RA.Options.Display.Body.Color.Glow.green.slider:SetPosition(math.floor(RA.Settings.Color.Glow.colorG*255))
					RA.Options.Display.Body.Color.Glow.green.slider:EventAttach(Event.UI.Slider.Change, function()
						RA.Options.Display.Body.Color.Glow.green.value:SetText(tostring(RA.Options.Display.Body.Color.Glow.green.slider:GetPosition()))
						RA.Options.Display.Body.Color.Glow.preview:SetBackgroundColor(RA.Options.Display.Body.Color.Glow.red.slider:GetPosition()/255,RA.Options.Display.Body.Color.Glow.green.slider:GetPosition()/255,RA.Options.Display.Body.Color.Glow.blue.slider:GetPosition()/255,1)
						RA.Settings.Color.Glow.colorG = RA.Options.Display.Body.Color.Glow.green.slider:GetPosition()/255
						RA.Alert:SetEffectGlow(RA.Settings.Color.Glow)
					end, AddonId .. "_Options_Display_Body_Color_green_slider_Change")
				
				RA.Options.Display.Body.Color.Glow.green.value = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_green_value", RA.Options.Display.Body.Color.Glow.green)
					RA.Options.Display.Body.Color.Glow.green.value:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Glow.green.slider, "CENTERRIGHT", 12, -6)
					RA.Options.Display.Body.Color.Glow.green.value:SetFontColor(1,1,1,1)
					RA.Options.Display.Body.Color.Glow.green.value:SetFontSize(12)
					RA.Options.Display.Body.Color.Glow.green.value:SetText(tostring(RA.Options.Display.Body.Color.Glow.green.slider:GetPosition()))
			
			RA.Options.Display.Body.Color.Glow.blue = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_blue", RA.Options.Display.Body.Color.Glow)
				RA.Options.Display.Body.Color.Glow.blue:SetPoint("BOTTOMLEFT", RA.Options.Display.Body.Color.Glow.border, "BOTTOMRIGHT", 19, 0)
				RA.Options.Display.Body.Color.Glow.blue:SetFontColor(1,1,1,1)
				RA.Options.Display.Body.Color.Glow.blue:SetFontSize(12)
				RA.Options.Display.Body.Color.Glow.blue:SetText("Blue")
			
				RA.Options.Display.Body.Color.Glow.blue.slider = UI.CreateFrame("RiftSlider", AddonId .. "_Options_Display_Body_Color_blue_slider", RA.Options.Display.Body.Color.Glow.blue)
					RA.Options.Display.Body.Color.Glow.blue.slider:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Glow.blue, "CENTERRIGHT", 12, 6)
					RA.Options.Display.Body.Color.Glow.blue.slider:SetRange(0,255)
					RA.Options.Display.Body.Color.Glow.blue.slider:SetWidth(165)
					RA.Options.Display.Body.Color.Glow.blue.slider:SetPosition(math.floor(RA.Settings.Color.Glow.colorB*255))
					RA.Options.Display.Body.Color.Glow.blue.slider:EventAttach(Event.UI.Slider.Change, function()
						RA.Options.Display.Body.Color.Glow.blue.value:SetText(tostring(RA.Options.Display.Body.Color.Glow.blue.slider:GetPosition()))
						RA.Options.Display.Body.Color.Glow.preview:SetBackgroundColor(RA.Options.Display.Body.Color.Glow.red.slider:GetPosition()/255,RA.Options.Display.Body.Color.Glow.green.slider:GetPosition()/255,RA.Options.Display.Body.Color.Glow.blue.slider:GetPosition()/255,1)
						RA.Settings.Color.Glow.colorB = RA.Options.Display.Body.Color.Glow.blue.slider:GetPosition()/255
						RA.Alert:SetEffectGlow(RA.Settings.Color.Glow)
					end, AddonId .. "_Options_Display_Body_Color_blue_slider_Change")
				
				RA.Options.Display.Body.Color.Glow.blue.value = UI.CreateFrame("Text", AddonId .. "_Options_Display_Body_Color_blue_value", RA.Options.Display.Body.Color.Glow.blue)
					RA.Options.Display.Body.Color.Glow.blue.value:SetPoint("CENTERLEFT", RA.Options.Display.Body.Color.Glow.blue.slider, "CENTERRIGHT", 12, -6)
					RA.Options.Display.Body.Color.Glow.blue.value:SetFontColor(1,1,1,1)
					RA.Options.Display.Body.Color.Glow.blue.value:SetFontSize(12)
					RA.Options.Display.Body.Color.Glow.blue.value:SetText(tostring(RA.Options.Display.Body.Color.Glow.blue.slider:GetPosition()))
				
				
				
	RA.Options.Display:EventAttach(Event.UI.Input.Mouse.Wheel.Back, RA.Function.Event.WheelBack, AddonId .. "_Options_Display_WheelBack")
	RA.Options.Display:EventAttach(Event.UI.Input.Mouse.Wheel.Forward, RA.Function.Event.WheelForward, AddonId .. "_Options_Display_WheelForward")
	RA.Options.Display.Scrollbar.handle:EventAttach(Event.UI.Input.Mouse.Left.Down, RA.Function.Event.LeftDown, AddonId .. "_Options_Display_ScrollBar_LeftDown")
	RA.Options.Display.Scrollbar.handle:EventAttach(Event.UI.Input.Mouse.Left.Up, RA.Function.Event.LeftUp, AddonId .. "_Options_Display_ScrollBar_LeftUp")
	RA.Options.Display.Scrollbar.handle:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, RA.Function.Event.LeftUp, AddonId .. "_Options_Display_ScrollBar_LeftUpOutside")
	RA.Options.Title:EventAttach(Event.UI.Input.Mouse.Left.Down, RA.Function.Event.LeftDown, AddonId .. "_Options_Title_LeftDown")
	RA.Options.Title:EventAttach(Event.UI.Input.Mouse.Left.Up, RA.Function.Event.LeftUp, AddonId .. "_Options_Title_LeftUp")
	RA.Options.Title:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, RA.Function.Event.LeftUp, AddonId .. "_Options_Title_LeftUpOutside")
	
	if RA.Alert then
		RA.Alert:SetVisible(true)
		RA.Alert.Frame:SetVisible(true)
	else
		RA.CreateAlert()
	end

end

function RA.CreateAlert()
	if next(RA.Settings) == nil then
		RA.CreateSettings()
	else
		RA.Alert = UI.CreateFrame("Text", AddonId .. "_Alert", RA.AlertContext)
		
			RA.Alert.Frame = UI.CreateFrame("Frame", AddonId .. "_Alert_Frame", RA.Alert)
				RA.Alert.Frame:SetPoint("CENTER", RA.AlertContext, "TOPLEFT", RA.Settings.Location.X, RA.Settings.Location.Y)
				RA.Alert.Frame:SetBackgroundColor(1,1,1,0)
				RA.Alert.Frame:SetVisible(false)
			
			RA.Alert:SetPoint("CENTER", RA.Alert.Frame, "CENTER")
			RA.Alert:SetVisible(false)
			RA.Alert:SetFontColor(RA.Settings.Color.Text.r,RA.Settings.Color.Text.g,RA.Settings.Color.Text.b,1)
			RA.Alert:SetFontSize(RA.Settings.Size)
			RA.Alert:SetText("Guild Rally!")
			RA.Alert:SetEffectGlow(RA.Settings.Color.Glow)
			
				RA.Alert.Frame:SetWidth(RA.Alert:GetWidth())
				RA.Alert.Frame:SetHeight(RA.Alert:GetHeight())
			
		RA.Alert.Frame:EventAttach(Event.UI.Input.Mouse.Left.Down, RA.Function.Event.LeftDown, AddonId .. "_Alert_LeftDown")
		RA.Alert.Frame:EventAttach(Event.UI.Input.Mouse.Left.Up, RA.Function.Event.LeftUp, AddonId .. "_Alert_LeftUp")
		RA.Alert.Frame:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, RA.Function.Event.LeftUp, AddonId .. "_Alert_LeftUpOutside")
	end
end

function RA.CreateSettings()
	RA.Settings.Scroll = false
	RA.Settings.Size = 80
	RA.Settings.Timeout = 300
	RA.Settings.Color = {}
	RA.Settings.Color.Text = {r=0,g=0,b=0}
	RA.Settings.Color.Glow = {blurX=3,blurY=3,colorR=0.91,colorG=0.424,colorB=0.098,strength=5}
	RA.Settings.Location = {}
	RA.Settings.Location.X = UIParent:GetWidth()/2
	RA.Settings.Location.Y = UIParent:GetHeight()/4
	
	RA.CreateAlert()
end

function RA.Function.Event.WheelBack(handle)
	RA.Function.UpdateBody("WheelBack")
end

function RA.Function.Event.WheelForward(handle)
	RA.Function.UpdateBody("WheelForward")
end

function RA.Function.Event.LeftDown(handle)
	if handle:GetName() == AddonId .. "_Options_Title" then
		RA.Options.Mouse = {}
		RA.Options.dragging = true
		local mouse = Inspect.Mouse()
		local top = RA.Options:GetTop()
		local left = RA.Options:GetLeft()
		RA.Options.Mouse.x = ((mouse.x - left)/RA.Options:GetWidth())
		RA.Options.Mouse.y = ((mouse.y - top)/RA.Options:GetHeight())
	elseif handle:GetName() == AddonId .. "_Alert_Frame" then
		if RA.Options and RA.Options:GetVisible() then
			RA.Alert.Mouse = {}
			RA.Alert.dragging = true
			local mouse = Inspect.Mouse()
			local top = RA.Alert.Frame:GetTop()
			local left = RA.Alert.Frame:GetLeft()
			RA.Alert.Mouse.x = ((mouse.x - left)/RA.Alert.Frame:GetWidth())
			RA.Alert.Mouse.y = ((mouse.y - top)/RA.Alert.Frame:GetHeight())
		end
	elseif handle:GetName() == AddonId .. "_Options_Display_Body_ScrollBar_Line_handle" then
		RA.Options.Display.Scrollbar.Mouse = {}
		RA.Options.Display.Scrollbar.dragging = true
		local mouse = Inspect.Mouse()
		local top = RA.Options.Display.Scrollbar.handle:GetTop()
		RA.Options.Display.Scrollbar.Mouse.y = ((mouse.y - top)/RA.Options.Display.Scrollbar.line:GetHeight())
	end
end

function RA.Function.Event.LeftUp(handle)
	if handle:GetName() == AddonId .. "_Options_Title" then
		RA.Options.dragging = false
	elseif handle:GetName() == AddonId .. "_Alert_Frame" then
		RA.Alert.dragging = false
		local left, top, right, bottom = RA.Alert.Frame:GetBounds()
		RA.Settings.Location.X = (right-left)/2 + left
		RA.Settings.Location.Y = (bottom-top)/2 + top
	elseif handle:GetName() == AddonId .. "_Options_Display_Body_ScrollBar_Line_handle" then
		RA.Options.Display.Scrollbar.dragging = false
	end
end

function RA.Function.Event.MouseMove(handle, xcoord, ycoord)
	if RA.Alert then
		if RA.Alert.Frame then
			if RA.Alert.dragging then
				local points = RA.Alert.Frame:ReadAll()
				local x,y
				for key, value in pairs(points.x) do
					if type(key) == "number" and key >= 0 then
						x = key
					end
				end
				for key, value in pairs(points.y) do
					if type(key) == "number" and key >= 0 then
						y = key
					end
				end
				RA.Alert.Frame:ClearPoint(x,y)
				RA.Alert.Frame:SetPoint(RA.Alert.Mouse.x, RA.Alert.Mouse.y, RA.AlertContext, "TOPLEFT", xcoord, ycoord)
			end
		end
	end
	if RA.Options then
		if RA.Options.Title then
			if RA.Options.dragging then
				local points = RA.Options:ReadAll()
				local x,y
				for key, value in pairs(points.x) do
					if type(key) == "number" and key >= 0 then
						x = key
					end
				end
				for key, value in pairs(points.y) do
					if type(key) == "number" and key >= 0 then
						y = key
					end
				end
				RA.Options:ClearPoint(x,y)
				RA.Options:SetPoint(RA.Options.Mouse.x, RA.Options.Mouse.y, RA.Context, "TOPLEFT", xcoord, ycoord)
			end
		end
	end
	if RA.Options then
		if RA.Options.Display then
			if RA.Options.Display.Scrollbar then
				if RA.Options.Display.Scrollbar.dragging then
					local lineHeight = RA.Options.Display.Scrollbar.line:GetHeight()
					local handleHeight = RA.Options.Display.Scrollbar.handle:GetHeight()
					local handleTop = RA.Options.Display.Scrollbar.handle:GetTop()
					local lineTop = RA.Options.Display.Scrollbar.line:GetTop()
					local handleLinePercent = ((handleTop - lineTop)/lineHeight)
					local mouseLinePercent = ((ycoord - lineTop)/lineHeight)
					local movePercent = mouseLinePercent - RA.Options.Display.Scrollbar.Mouse.y
					local maskHeight = RA.Options.Display:GetHeight()
					local bodyHeight = RA.Options.Display.Body:GetHeight()
					local totalTravelBody = math.abs(1-(bodyHeight/maskHeight))
					local movePercentdisplay = -movePercent * (bodyHeight/maskHeight)
					if handleLinePercent > RA.Options.Display.Scrollbar.handle.range then
						handleLinePercent = RA.Options.Display.Scrollbar.handle.range
					end
					if (handleLinePercent <= RA.Options.Display.Scrollbar.handle.range and movePercent <= RA.Options.Display.Scrollbar.handle.range) and (handleLinePercent >= 0 and movePercent >= 0) then
						RA.Options.Display.Body:SetPoint("TOPLEFT", RA.Options.Display, 0, movePercentdisplay)
						RA.Options.Display.Scrollbar.handle:SetPoint("TOPCENTER", RA.Options.Display.Scrollbar.line, 0.5, movePercent)
					elseif movePercent > RA.Options.Display.Scrollbar.handle.range then
						RA.Options.Display.Body:SetPoint("TOPLEFT", RA.Options.Display, 0, -totalTravelBody)
						RA.Options.Display.Scrollbar.handle:SetPoint("TOPCENTER", RA.Options.Display.Scrollbar.line, 0.5, RA.Options.Display.Scrollbar.handle.range)
					elseif movePercent < 0 then
						RA.Options.Display.Body:SetPoint("TOPLEFT", RA.Options.Display, 0,0)
						RA.Options.Display.Scrollbar.handle:SetPoint("TOPCENTER", RA.Options.Display.Scrollbar.line, 0.5, 0)
					end
				end
			end
		end
	end
end

function RA.Function.UpdateBody(updateType)
	local positionBody = RA.Options.Display.Body:ReadAll().y[0].position
	local positionHandle = RA.Options.Display.Scrollbar.handle:ReadAll().y[0].position
	local maskHeight = RA.Options.Display:GetHeight()
	local bodyHeight = RA.Options.Display.Body:GetHeight()
	local totalTravelBody = math.abs(1-(bodyHeight/maskHeight))
	local totalTravelHandle = 1-(maskHeight/bodyHeight)
	local changePercent
	if maskHeight/bodyHeight > 0.75 then
		changePercent = 1
	else
		changePercent = (maskHeight/bodyHeight)*0.35
	end
	local changeBody = totalTravelBody*changePercent
	local changeHandle = totalTravelHandle*changePercent
	if updateType == "WheelForward" then
		if positionBody <= -changeBody then
			RA.Options.Display.Body:SetPoint("TOPLEFT", RA.Options.Display, 0, positionBody+changeBody)
			RA.Options.Display.Scrollbar.handle:SetPoint("TOPCENTER", RA.Options.Display.Scrollbar.line, 0.5, positionHandle-changeHandle)
		elseif positionBody < 0 and positionBody > -changeBody then
			RA.Options.Display.Body:SetPoint("TOPLEFT", RA.Options.Display, 0,0)
			RA.Options.Display.Scrollbar.handle:SetPoint("TOPCENTER", RA.Options.Display.Scrollbar.line, 0.5,0)
		end
	elseif updateType == "WheelBack" then
		if math.abs(positionBody-changeBody) <= totalTravelBody then
			RA.Options.Display.Body:SetPoint("TOPLEFT", RA.Options.Display, 0, positionBody-changeBody)
			RA.Options.Display.Scrollbar.handle:SetPoint("TOPCENTER", RA.Options.Display.Scrollbar.line, 0.5, positionHandle+changeHandle)
		else
			RA.Options.Display.Body:SetPoint("TOPLEFT", RA.Options.Display, 0, -totalTravelBody)
			RA.Options.Display.Scrollbar.handle:SetPoint("TOPCENTER", RA.Options.Display.Scrollbar.line, 0.5, RA.Options.Display.Scrollbar.handle.range)
		end
	end
end

function RA.Function.Event.Update(hEvent)

	local ServerTime = Inspect.Time.Server()

	if RA.RallyTimeout ~= 0 and RA.RallyTimeTriggered ~= 0 then
		if RA.RallyTimeout == ServerTime then
			RA.ClearRallyMaunal()
		end
	end
	
	if RA.RedoItemUpdate == true and RA.ItemRescanTime ~= 0 then
		if RA.ItemRescanTime == ServerTime then
			RA.ItemUpdate()
		end
	end
	
end


--[[function RA.AbilityCDBegin(hEvent, abilities)
	if RA.CountTableSize(abilities) == 1 and RA.Items.Banners.HasBanners then
		for id, t in pairs(abilities) do
			if id == "A5F77DAA65FAED9E3" then
				RA.RallyTimeTriggered = Inspect.Time.Server()
				RA.RallyTimeout = RA.RallyTimeTriggered + 1
			end
		end
	end
end]]--

function RA.CheckForRally(hEvent, abilities)
	if RA.CountTableSize(abilities) == 1 and RA.Items.Banners.HasBanners then
		for id, t in pairs(abilities) do
			if id == "A5F77DAA65FAED9E3" then
				if RA.Settings.Scroll and RA.Items.Scrolls.OnCooldown then
					return
				else
					local banner = Inspect.Ability.New.Detail(id)
					if banner.currentCooldownRemaining and banner.currentCooldownRemaining > 2998 then
						return
					else
						RA.RallyBannerUsable = false
						RA.RallyTimeTriggered = Inspect.Time.Server()
						RA.RallyTimeout = RA.RallyTimeTriggered + RA.Settings.Timeout
						Command.System.Flash(true)
						RA.Alert:SetVisible(true)
						return
					end
				end
			end
		end
	end
end

function RA.ClearRally(hEvent, abilities)
	if RA.CountTableSize(abilities) == 1 and RA.Items.Banners.HasBanners then
		for id, t in pairs(abilities) do
			if id == "A5F77DAA65FAED9E3" then
				RA.RallyBannerUsable = true
				RA.RallyTimeTriggered = 0
				RA.RallyTimeout = 0
				Command.System.Flash(false)
				if RA.Options and RA.Options:GetVisible() then
					return
				else
					RA.Alert:SetVisible(false)
				end
				return
			end
		end
	end
end

function RA.ClearRallyMaunal()
	RA.RallyBannerUsable = true
	RA.RallyTimeTriggered = 0
	RA.RallyTimeout = 0
	Command.System.Flash(false)
	if RA.Options and RA.Options:GetVisible() then
		return
	else
		RA.Alert:SetVisible(false)
	end
	return
end

function RA.ItemUpdate(hEvent, updatedItems)
	if RA.Availability == "full" then
		local items = Inspect.Item.List('si')
		if items['si01.001'] then
			RA.RedoItemUpdate = false
			RA.ItemRescanTime = 0
			for slot, id in pairs(items) do
				if id then
					local details = Inspect.Item.Detail(id)
					if details then
						if details.type and details.type == "I087D01FD423C0BEB,A82B6A703D33B4B6,,,,,," then
							RA.Items.Banners.HasBanners = true
							RA.Items.Banners.location = slot
						elseif details.type and details.type == "I1F832DB376787EBF,D912113BAA7304B3,,,,,," then
							RA.Items.Scrolls.HasScrolls = true
							RA.Items.Scrolls.location = slot
							if details.cooldownRemaining then
								RA.Items.Scrolls.OnCooldown = true
								RA.ClearRallyMaunal()
							else
								RA.Items.Scrolls.OnCooldown = false
							end
						end
					end
					if RA.Items.Banners.HasBanners and RA.Items.Scrolls.HasScrolls then
						return
					end
				end
			end
			RA.ItemUpdateWait = false
		else
			RA.RedoItemUpdate = true
			RA.ItemRescanTime = Inspect.Time.Server() + 1
		end
	else
		if updatedItems and updatedItems[RA.Items.Scrolls.location] then
			local details = Inspect.Item.Detail(updatedItems[RA.Items.Scrolls.location])
			if details.cooldownRemaining then
				RA.Items.Scrolls.OnCooldown = true
				RA.ClearRallyMaunal()
			else
				RA.Items.Scrolls.OnCooldown = false
			end
		end
		RA.ItemUpdateWait = true
	end
end

function RA.AvailabilityFull(hEvent, units)
	for id, unit in pairs(units) do
		if unit == "player" then
			RA.Availability = "full"
			if RA.ItemUpdateWait then
				RA.ItemUpdate()
			end
			return
		end
	end
end

function RA.AvailabilityPartial(hEvent, units)
	for id, unit in pairs(units) do
		if unit == "player" then
			RA.Availability = "partial"
			RA.ItemUpdateWait = true
			return
		end
	end
end

function RA.AvailabilityNone(hEvent, units)
	for id, unit in pairs(units) do
		if unit == "player" then
			RA.Availability = "none"
			RA.ItemUpdateWait = true
			return
		end
	end
end

function RA.CountTableSize(table)
	local n = 0
    for k, v in pairs(table) do
        n = n + 1
    end
    return n
end

local function AddonLoaded(hEvent)
	RA.CreateAlert()
end

local function ConsoleLoaded(handle)
	for id, test in pairs(Inspect.Console.List()) do
		if Inspect.Console.Detail(id).name ~= "*Combat" then
			Command.Console.Display(id, false, "<font color='#E86C19'>Rally Alert Loaded</font>", true)
		end
	end
end

local function SavedDataLoaded(hEvent, id)
	if id == AddonId then
		RA.Settings = _G["RallyAlert"] or {}
	end
end

local function SaveDataBegin(hEvent, id)
	if id == AddonId then
		 _G["RallyAlert"] = RA.Settings
	end
end

function RA.OnSlashCommand(option)
	if option and option == "clear" then
		RA.ClearRallyMaunal()
	else
		if (not RA.Options) then
			RA.CreateOptions()
		else
			RA.Options:SetVisible(not RA.Options:GetVisible())
			RA.Alert.Frame:SetVisible(RA.Options:GetVisible())
			if RA.RallyBannerUsable == true then
				RA.Alert:SetVisible(not RA.Alert:GetVisible())
			else
				RA.Alert:SetVisible(true)
			end
		end
	end
end

table.insert(Command.Slash.Register("ral"), { RA.OnSlashCommand, AddonId, AddonId .. "_OnSlashCommand" })

UI.Native.Console1:EventAttach(Event.UI.Native.Loaded, ConsoleLoaded, AddonId .. "_Native_Console_Loaded")

Command.Event.Attach(Event.Addon.Startup.End, AddonLoaded, AddonId .. "_AddonLoaded" )
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, SavedDataLoaded, AddonId .. "_SavedDataLoaded" )
Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, SaveDataBegin, AddonId .. "_SavedDataLoaded" )
Command.Event.Attach(Event.System.Update.Begin, RA.Function.Event.Update, AddonId .. "_SystemUpdate")
Command.Event.Attach(Event.Mouse.Move, RA.Function.Event.MouseMove, AddonId .. "_MouseMove")

Command.Event.Attach(Event.Ability.New.Usable.False, RA.CheckForRally, AddonId .. "_AbilityUsableFalse" )
Command.Event.Attach(Event.Ability.New.Usable.True, RA.ClearRally, AddonId .. "_AbilityUsableTrue" )
--Command.Event.Attach(Event.Ability.New.Cooldown.Begin, RA.AbilityCDBegin, AddonId .. "_AbilityCDBegin" )
Command.Event.Attach(Event.Item.Slot, RA.ItemUpdate, AddonId .. "_ItemSlot" )
Command.Event.Attach(Event.Item.Update, RA.ItemUpdate, AddonId .. "_ItemUpdate" )

Command.Event.Attach(Event.Unit.Availability.Full, RA.AvailabilityFull, AddonId .. "_AvailabilityFull" )
Command.Event.Attach(Event.Unit.Availability.Partial, RA.AvailabilityPartial, AddonId .. "_AvailabilityPartial" )
Command.Event.Attach(Event.Unit.Availability.None, RA.AvailabilityNone, AddonId .. "_AvailabilityNone" )